/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014-2016 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_task.h 167 2016-03-08 11:37:45Z coas-nagasima $
 */

/*
 *		ECHONET Lite ^XN
 */

#ifndef TOPPERS_ECHONET_TASK_H
#define TOPPERS_ECHONET_TASK_H

/*#include ".h"*/

#include "echonet_rename.h"
#include "echonet.h"
#include "echonet_fbs.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ECHONET Lite ^XN֘A̒萔̃ftHgl̒`
 */ 
#ifndef ECHONET_TASK_PRIORITY
#define ECHONET_TASK_PRIORITY	3		/* Dx */
#endif /* ECHONET_TASK_PRIORITY */

#ifndef ECHONET_TASK_STACK_SIZE
#define ECHONET_TASK_STACK_SIZE	1024	/* X^bN̈̃TCY */
#endif /* ECHONET_TASK_STACK_SIZE */

extern const EOBJINIB _echonet_eobjinib_table[];
extern EOBJCB _echonet_eobjcb_table[];
extern ENODADRB _echonet_enodadrb_table[];

/*
 *  ECHONET Lite ^XN̖{
 */
void echonet_task(intptr_t exinf);

/* ECHONET Lite CX^XXg1AiEXőm[h */
#define ECN_IST_LST_EOJ_MAX_CT (84)

/* ECHONET LiteIuWFNgR[h x1,x2,x3(T_ECN_EOJ)24bitɕϊ */
#define _ECN_EOJ2VALUE(s) (((s).eojx1 << 16) | ((s).eojx2 << 8) | (s).eojx3)

enum ecn_epc_code
{
	ECN_EPC_INL_BCS		=	0xD5	/* CX^XXgʒmvpeB */
};

typedef enum
{
	ECN_MSG_UNDEF		=	0,
	ECN_MSG_INTERNAL	=	1,
	ECN_MSG_ECHONET		=	2,
	ECN_MSG_USER_BREAK	=	3
} ECN_MSG_TYPE;

typedef enum
{
	ECN_INM_NOTIFY_INSTANCELIST = 1,
	ECN_INM_GET_DEVICE_LIST_REQ,
	ECN_INM_GET_DEVICE_LIST_RES,
	ECN_INM_GET_DEVICE_INFO_REQ,
	ECN_INM_GET_DEVICE_INFO_RES,
	ECN_UDP_MSG_GET_IPADDR_REQ,
	ECN_UDP_MSG_GET_IPADDR_RES,
	ECN_UDP_MSG_GET_IPADDR_ERROR
} ECN_INT_MSG_COMMAND;

typedef struct
{
	uint8_t	command;
	uint8_t	data[1];
} T_ECN_INTERNAL_MSG;

/*
 * vd쐬
 */
ER _ecn_tsk_mk_esv(ECN_FBS_ID *fp_fbs_id, ID fa_seoj, ID fa_deoj,
	uint8_t fa_epc, uint8_t fa_pdc, const void *p_edt, ECN_SRV_CODE fa_esv);

ER _ecn_tsk_snd_mbx(ECN_FBS_ID fa_rsp_fbs, bool_t from_app);

/*
 * d҂̊荞ݓd쐬
 */
ER _ecn_mk_brk_wai(ECN_FBS_ID *pk_fbs_id, const void *p_dat, size_t fa_size);

const EOBJCB *_ecn_eno_fnd(ECN_ENOD_ID enodid);

const EOBJINIB *_ecn_eoj_fnd(const EOBJCB *fp_nod, const T_ECN_EOJ *fp_eoj);

ER _ecn_tsk_cre_req_fbs(ID sender, uint8_t cmd, ECN_FBS_ID *pk_req);

ER _ecn_tsk_cre_res_fbs(ECN_FBS_ID req, uint8_t cmd, ECN_FBS_ID *pk_res);

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_ECHONET_TASK_H */
